package quimufu.colourful_portals.portal_fluid;

import net.minecraft.util.StringIdentifiable;
import net.minecraft.util.math.Direction;
import org.jetbrains.annotations.Nullable;

public enum NullableAxis implements StringIdentifiable {
    X(Direction.Axis.X),
    Y(Direction.Axis.Y),
    Z(Direction.Axis.Z),
    NULL(null);

    private final Direction.Axis axis;

    NullableAxis(Direction.Axis axis) {

        this.axis = axis;
    }

    public static NullableAxis of(Direction.Axis currentAxis) {
        if (currentAxis == null){
            return NULL;
        }
        switch (currentAxis) {
            case X -> {
                return X;
            }
            case Y -> {
                return Y;
            }
            case Z -> {
                return Z;
            }
        }
        return NULL;
    }

    @Nullable
    public Direction.Axis getAxis() {
        return axis;
    }

    @Override
    public String asString() {
        return this == NULL ? "null" : axis.asString();
    }
}
